"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classnames = _interopRequireDefault(require("classnames"));
var _react = _interopRequireDefault(require("react"));
var _excluded = ["checked", "children", "className", "containerProps", "disabled", "indeterminate", "inline", "label"];
/**
 * SPDX-FileCopyrightText: © 2019 Liferay, Inc. <https://liferay.com>
 * SPDX-License-Identifier: BSD-3-Clause
 */
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) { ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) { o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) { if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } } return t; }
var Checkbox = /*#__PURE__*/_react.default.forwardRef(function (_ref, _ref2) {
  var checked = _ref.checked,
    children = _ref.children,
    className = _ref.className,
    _ref$containerProps = _ref.containerProps,
    containerProps = _ref$containerProps === void 0 ? {} : _ref$containerProps,
    disabled = _ref.disabled,
    _ref$indeterminate = _ref.indeterminate,
    indeterminate = _ref$indeterminate === void 0 ? false : _ref$indeterminate,
    inline = _ref.inline,
    label = _ref.label,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  var inputRef = _react.default.useRef(null);
  _react.default.useEffect(function () {
    if (inputRef.current) {
      inputRef.current.indeterminate = indeterminate;
    }
  }, [indeterminate]);
  return /*#__PURE__*/_react.default.createElement("div", _extends({}, containerProps, {
    className: (0, _classnames.default)('custom-control custom-checkbox', containerProps.className, {
      'custom-control-inline': inline,
      'custom-control-outside': label
    })
  }), /*#__PURE__*/_react.default.createElement("label", null, /*#__PURE__*/_react.default.createElement("input", _extends({}, otherProps, {
    checked: checked,
    className: (0, _classnames.default)('custom-control-input', className),
    disabled: disabled,
    ref: function ref(r) {
      inputRef.current = r;
      if (typeof _ref2 === 'function') {
        _ref2(r);
      }
    },
    type: "checkbox"
  })), /*#__PURE__*/_react.default.createElement("span", {
    className: "custom-control-label"
  }, label && /*#__PURE__*/_react.default.createElement("span", {
    className: "custom-control-label-text"
  }, label)), children));
});
Checkbox.displayName = 'ClayCheckbox';
var _default = exports.default = Checkbox;