"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _button = require("@clayui/button");
var _shared = require("@clayui/shared");
var _classnames = _interopRequireDefault(require("classnames"));
var _react = _interopRequireDefault(require("react"));
var _Form = _interopRequireDefault(require("./Form"));
var _SelectBox = _interopRequireWildcard(require("./SelectBox"));
var _excluded = ["ariaLabels", "className", "disabled", "disableLTR", "disableRTL", "items", "left", "leftMaxItems", "onItemsChange", "right", "rightMaxItems", "size", "spritemap"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) { if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) { ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) { o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) { if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } } return t; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) { n[e] = r[e]; } return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0) { ; } } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; } /**
 * SPDX-FileCopyrightText: © 2020 Liferay, Inc. <https://liferay.com>
 * SPDX-License-Identifier: BSD-3-Clause
 */
function swapArrayItems(arrays, selectedIndexes) {
  var _arrays = _slicedToArray(arrays, 2),
    sourceArray = _arrays[0],
    targetArray = _arrays[1];
  var newTargetArray = _toConsumableArray(targetArray);
  var newSourceArray = sourceArray.filter(function (item, index) {
    if (selectedIndexes.includes(index)) {
      newTargetArray.push(item);
      return false;
    }
    return true;
  });
  return [newSourceArray, newTargetArray];
}
var defaultError = 'The maximum number of items for {0} is {1}';
var DualListBox = function DualListBox(_ref) {
  var _ref$ariaLabels = _ref.ariaLabels,
    ariaLabels = _ref$ariaLabels === void 0 ? {
      error: defaultError,
      transferLTR: 'Transfer Item Left to Right',
      transferRTL: 'Transfer Item Right to Left'
    } : _ref$ariaLabels,
    className = _ref.className,
    disabled = _ref.disabled,
    disableLTR = _ref.disableLTR,
    disableRTL = _ref.disableRTL,
    _ref$items = _ref.items,
    items = _ref$items === void 0 ? [[], []] : _ref$items,
    _ref$left = _ref.left,
    left = _ref$left === void 0 ? {} : _ref$left,
    leftMaxItems = _ref.leftMaxItems,
    _onItemsChange = _ref.onItemsChange,
    _ref$right = _ref.right,
    right = _ref$right === void 0 ? {} : _ref$right,
    rightMaxItems = _ref.rightMaxItems,
    size = _ref.size,
    spritemap = _ref.spritemap,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  var _React$useState = _react.default.useState(left.selected || []),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    internalLeftSelected = _React$useState2[0],
    setInternalLeftSelected = _React$useState2[1];
  var _React$useState3 = _react.default.useState(right.selected || []),
    _React$useState4 = _slicedToArray(_React$useState3, 2),
    internalRightSelected = _React$useState4[0],
    setInternalRightSelected = _React$useState4[1];
  var handleLeftSelectedChange = left.onSelectChange || setInternalLeftSelected;
  var handleRightSelectedChange = right.onSelectChange || setInternalRightSelected;
  var leftSelected = left.selected || internalLeftSelected;
  var rightSelected = right.selected || internalRightSelected;
  var _items = _slicedToArray(items, 2),
    leftItems = _items[0],
    rightItems = _items[1];
  var selectedIndexesLeft = (0, _SelectBox.getSelectedIndexes)(leftItems, leftSelected);
  var selectedIndexesRight = (0, _SelectBox.getSelectedIndexes)(rightItems, rightSelected);
  var isLeftError = leftMaxItems ? rightSelected.length + leftItems.length > leftMaxItems : false;
  var isRightError = rightMaxItems ? leftSelected.length + rightItems.length > rightMaxItems : false;
  var hasMaxItemsLeft = leftMaxItems ? leftItems.length >= leftMaxItems : false;
  var hasMaxItemsRight = rightMaxItems ? rightItems.length >= rightMaxItems : false;
  return /*#__PURE__*/_react.default.createElement("div", _extends({}, otherProps, {
    className: (0, _classnames.default)(className, 'form-group')
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "clay-dual-listbox"
  }, /*#__PURE__*/_react.default.createElement(_SelectBox.default, {
    className: "clay-dual-listbox-item clay-dual-listbox-item-expand listbox-left",
    disabled: disabled,
    id: left.id,
    items: leftItems,
    label: left.label,
    multiple: true,
    onItemsChange: function onItemsChange(newLeftItems) {
      return _onItemsChange([newLeftItems, rightItems]);
    },
    onSelectChange: handleLeftSelectedChange,
    size: size,
    value: leftSelected
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "btn-group-vertical clay-dual-listbox-actions clay-dual-listbox-item"
  }, /*#__PURE__*/_react.default.createElement(_button.ClayButtonWithIcon, {
    "aria-label": ariaLabels.transferLTR,
    className: "transfer-button-ltr",
    disabled: disableLTR || hasMaxItemsRight || isRightError || disabled,
    displayType: "secondary",
    onClick: function onClick() {
      var _swapArrayItems = swapArrayItems([leftItems, rightItems], selectedIndexesLeft),
        _swapArrayItems2 = _slicedToArray(_swapArrayItems, 2),
        arrayLeft = _swapArrayItems2[0],
        arrayRight = _swapArrayItems2[1];
      _onItemsChange([arrayLeft, arrayRight]);
    },
    small: true,
    spritemap: spritemap,
    symbol: "caret-right"
  }), /*#__PURE__*/_react.default.createElement(_button.ClayButtonWithIcon, {
    "aria-label": ariaLabels.transferRTL,
    className: "transfer-button-rtl",
    disabled: disableRTL || hasMaxItemsLeft || isLeftError || disabled,
    displayType: "secondary",
    onClick: function onClick() {
      var _swapArrayItems3 = swapArrayItems([rightItems, leftItems], selectedIndexesRight),
        _swapArrayItems4 = _slicedToArray(_swapArrayItems3, 2),
        arrayRight = _swapArrayItems4[0],
        arrayLeft = _swapArrayItems4[1];
      _onItemsChange([arrayLeft, arrayRight]);
    },
    small: true,
    spritemap: spritemap,
    symbol: "caret-left"
  })), /*#__PURE__*/_react.default.createElement(_SelectBox.default, {
    className: "clay-dual-listbox-item clay-dual-listbox-item-expand listbox-right",
    disabled: disabled,
    id: right.id,
    items: rightItems,
    label: right.label,
    multiple: true,
    onItemsChange: function onItemsChange(newRightItems) {
      return _onItemsChange([leftItems, newRightItems]);
    },
    onSelectChange: handleRightSelectedChange,
    showArrows: true,
    size: size,
    spritemap: spritemap,
    value: rightSelected
  })), (isLeftError || isRightError) && /*#__PURE__*/_react.default.createElement(_Form.default.FeedbackGroup, {
    className: "has-error"
  }, /*#__PURE__*/_react.default.createElement(_Form.default.FeedbackItem, null, (0, _shared.sub)(ariaLabels.error || defaultError, [isLeftError ? left.label : right.label, isLeftError ? leftMaxItems : rightMaxItems]))));
};
var _default = exports.default = DualListBox;