"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Input = exports.GroupText = exports.GroupItem = exports.Group = void 0;
var _classnames = _interopRequireDefault(require("classnames"));
var _react = _interopRequireDefault(require("react"));
var _excluded = ["append", "children", "className", "prepend", "shrink"],
  _excluded2 = ["children", "className", "small", "stacked"],
  _excluded3 = ["children", "className"],
  _excluded4 = ["after", "before", "children", "className", "tag"],
  _excluded5 = ["className", "component", "insetAfter", "insetBefore", "sizing", "type"];
/**
 * SPDX-FileCopyrightText: © 2019 Liferay, Inc. <https://liferay.com>
 * SPDX-License-Identifier: BSD-3-Clause
 */
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) { ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } } return n; }, _extends.apply(null, arguments); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) { o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) { if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } } return t; }
var GroupItem = exports.GroupItem = /*#__PURE__*/_react.default.forwardRef(function (_ref, ref) {
  var _classNames;
  var append = _ref.append,
    children = _ref.children,
    className = _ref.className,
    prepend = _ref.prepend,
    shrink = _ref.shrink,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/_react.default.createElement("div", _extends({}, otherProps, {
    className: (0, _classnames.default)('input-group-item', className, (_classNames = {}, _defineProperty(_classNames, 'input-group-append', append), _defineProperty(_classNames, 'input-group-item-shrink', shrink), _defineProperty(_classNames, 'input-group-prepend', prepend), _classNames)),
    ref: ref
  }), children);
});
GroupItem.displayName = 'ClayInputGroupItem';
var Group = exports.Group = /*#__PURE__*/_react.default.forwardRef(function (_ref2, ref) {
  var _classNames2;
  var children = _ref2.children,
    className = _ref2.className,
    small = _ref2.small,
    stacked = _ref2.stacked,
    otherProps = _objectWithoutProperties(_ref2, _excluded2);
  return /*#__PURE__*/_react.default.createElement("div", _extends({}, otherProps, {
    className: (0, _classnames.default)('input-group', className, (_classNames2 = {}, _defineProperty(_classNames2, 'input-group-sm', small), _defineProperty(_classNames2, 'input-group-stacked-sm-down', stacked), _classNames2)),
    ref: ref
  }), children);
});
Group.displayName = 'ClayInputGroup';
var GroupText = exports.GroupText = /*#__PURE__*/_react.default.forwardRef(function (_ref3, ref) {
  var children = _ref3.children,
    className = _ref3.className,
    otherProps = _objectWithoutProperties(_ref3, _excluded3);
  return /*#__PURE__*/_react.default.createElement("div", _extends({}, otherProps, {
    className: (0, _classnames.default)('input-group-text', className),
    ref: ref
  }), children);
});
GroupText.displayName = 'ClayInputGroupText';
var GroupInsetItem = /*#__PURE__*/_react.default.forwardRef(function (_ref4, ref) {
  var _classNames3;
  var after = _ref4.after,
    before = _ref4.before,
    children = _ref4.children,
    className = _ref4.className,
    _ref4$tag = _ref4.tag,
    Tag = _ref4$tag === void 0 ? 'div' : _ref4$tag,
    otherProps = _objectWithoutProperties(_ref4, _excluded4);
  return /*#__PURE__*/_react.default.createElement(Tag, _extends({}, otherProps, {
    className: (0, _classnames.default)('input-group-inset-item', className, (_classNames3 = {}, _defineProperty(_classNames3, 'input-group-inset-item-after', after), _defineProperty(_classNames3, 'input-group-inset-item-before', before), _classNames3)),
    ref: ref // Hack to get around TS inaccurately referring the ref type
  }), children);
});
GroupInsetItem.displayName = 'ClayInputGroupInsetItem';
function forwardRef(component) {
  return /*#__PURE__*/_react.default.forwardRef(component);
}
var Input = exports.Input = forwardRef(function (_ref5, ref) {
  var _classNames4;
  var className = _ref5.className,
    _ref5$component = _ref5.component,
    Component = _ref5$component === void 0 ? 'input' : _ref5$component,
    insetAfter = _ref5.insetAfter,
    insetBefore = _ref5.insetBefore,
    _ref5$sizing = _ref5.sizing,
    sizing = _ref5$sizing === void 0 ? 'regular' : _ref5$sizing,
    _ref5$type = _ref5.type,
    type = _ref5$type === void 0 ? 'text' : _ref5$type,
    otherProps = _objectWithoutProperties(_ref5, _excluded5);
  return /*#__PURE__*/_react.default.createElement(Component, _extends({}, otherProps, {
    className: (0, _classnames.default)('form-control', className, (_classNames4 = {}, _defineProperty(_classNames4, "form-control-".concat(sizing), sizing && sizing !== 'regular'), _defineProperty(_classNames4, 'input-group-inset', insetAfter || insetBefore), _defineProperty(_classNames4, 'input-group-inset-after', insetAfter), _defineProperty(_classNames4, 'input-group-inset-before', insetBefore), _classNames4)),
    ref: ref,
    type: type
  }));
});
Input.displayName = 'ClayInput';
Input.Group = Group;
Input.GroupInsetItem = GroupInsetItem;
Input.GroupItem = GroupItem;
Input.GroupText = GroupText;
var _default = exports.default = Input;