/**
 * SPDX-FileCopyrightText: © 2019 Liferay, Inc. <https://liferay.com>
 * SPDX-License-Identifier: BSD-3-Clause
 */
import React from 'react';
interface IRadioProps extends React.InputHTMLAttributes<HTMLInputElement> {
    /**
     * Props for the outer most container element.
     */
    containerProps?: React.HTMLAttributes<HTMLDivElement>;
    /**
     * Flag to indicate if radio elements should display inline.
     */
    inline?: boolean;
    /**
     * Text to describe for radio element.
     */
    label?: React.ReactText;
    /**
     * Value provided if element is selected.
     */
    value: React.ReactText;
}
declare const Radio: React.ForwardRefExoticComponent<IRadioProps & React.RefAttributes<HTMLInputElement>>;
export default Radio;
