/**
 * SPDX-FileCopyrightText: © 2019 Liferay, Inc. <https://liferay.com>
 * SPDX-License-Identifier: BSD-3-Clause
 */
import React from 'react';
export declare const OptGroup: ({ children, ...otherProps }: React.OptgroupHTMLAttributes<HTMLOptGroupElement>) => JSX.Element;
export declare const Option: ({ label, ...otherProps }: React.OptionHTMLAttributes<HTMLOptionElement>) => JSX.Element;
interface IProps extends React.SelectHTMLAttributes<HTMLSelectElement> {
    /**
     * Flag to make the Select component only as wide as its contents.
     */
    shrink?: boolean;
    /**
     * Set the proportional size of the Select component.
     */
    sizing?: 'lg' | 'sm';
}
declare function Select({ children, className, shrink, sizing, ...otherProps }: IProps): JSX.Element;
declare namespace Select {
    var OptGroup: ({ children, ...otherProps }: React.OptgroupHTMLAttributes<HTMLOptGroupElement>) => JSX.Element;
    var Option: ({ label, ...otherProps }: React.OptionHTMLAttributes<HTMLOptionElement>) => JSX.Element;
}
export default Select;
