"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSelectedIndexes = exports.default = void 0;
var _button = _interopRequireWildcard(require("@clayui/button"));
var _shared = require("@clayui/shared");
var _classnames = _interopRequireDefault(require("classnames"));
var _react = _interopRequireDefault(require("react"));
var _excluded = ["ariaLabels", "buttonAlignment", "className", "disabled", "id", "items", "label", "multiple", "onItemsChange", "onSelectChange", "showArrows", "size", "spritemap", "value"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) { if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } } return n.default = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) { ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } } return n; }, _extends.apply(null, arguments); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) { o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) { if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } } return t; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) { n[e] = r[e]; } return n; } /**
 * SPDX-FileCopyrightText: © 2020 Liferay, Inc. <https://liferay.com>
 * SPDX-License-Identifier: BSD-3-Clause
 */
function arrayMove(arrayToMove, oldIndex, newIndex) {
  arrayToMove.splice(newIndex, 0, arrayToMove.splice(oldIndex, 1)[0]);
  return arrayToMove;
}
function reorderUp(array, selectedIndexes) {
  var clonedArray = _toConsumableArray(array);
  for (var i = 0; i < selectedIndexes.length; i++) {
    var item = selectedIndexes[i];
    if (item === 0) {
      return clonedArray;
    }
    clonedArray = arrayMove(clonedArray, item, item - 1);
  }
  return clonedArray;
}
function reorderDown(array, selectedIndexes) {
  var clonedArray = _toConsumableArray(array);
  for (var i = 0; i < selectedIndexes.length; i++) {
    var item = selectedIndexes[i];
    if (selectedIndexes.includes(clonedArray.length - 1)) {
      return clonedArray;
    }
    clonedArray = arrayMove(clonedArray, item, item + 1);
  }
  return clonedArray;
}
var getSelectedIndexes = exports.getSelectedIndexes = function getSelectedIndexes(items, selectedValues) {
  return items.reduce(function (acc, item, index) {
    if (selectedValues.includes(item.value)) {
      return [].concat(_toConsumableArray(acc), [index]);
    }
    return acc;
  }, []);
};
var SelectBox = function SelectBox(_ref) {
  var _ref$ariaLabels = _ref.ariaLabels,
    ariaLabels = _ref$ariaLabels === void 0 ? {
      reorderDown: 'Reorder Down',
      reorderUp: 'Reorder Up'
    } : _ref$ariaLabels,
    _ref$buttonAlignment = _ref.buttonAlignment,
    buttonAlignment = _ref$buttonAlignment === void 0 ? 'end' : _ref$buttonAlignment,
    className = _ref.className,
    disabled = _ref.disabled,
    id = _ref.id,
    items = _ref.items,
    label = _ref.label,
    multiple = _ref.multiple,
    onItemsChange = _ref.onItemsChange,
    onSelectChange = _ref.onSelectChange,
    showArrows = _ref.showArrows,
    size = _ref.size,
    spritemap = _ref.spritemap,
    value = _ref.value,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  var selectedIndexes = getSelectedIndexes(items, Array.isArray(value) ? value : [value]);
  var noItems = !items.length;
  var noItemsSelected = !selectedIndexes.length;
  var firstItemSelected = selectedIndexes.includes(0);
  var lastItemSelected = selectedIndexes.includes(items.length - 1);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)(className, 'form-group')
  }, label && /*#__PURE__*/_react.default.createElement("label", {
    className: (0, _classnames.default)('reorder-label', {
      disabled: disabled
    }),
    htmlFor: id
  }, label), /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)('clay-reorder', _defineProperty({}, "clay-reorder-footer-".concat(buttonAlignment), buttonAlignment))
  }, /*#__PURE__*/_react.default.createElement("select", _extends({}, otherProps, {
    className: "form-control form-control-inset",
    disabled: disabled,
    id: id,
    multiple: multiple,
    onChange: function onChange(event) {
      var selectedItems = _toConsumableArray(event.target.options).filter(function (_ref2) {
        var selected = _ref2.selected;
        return selected;
      }).map(function (item) {
        return item.value;
      });
      onSelectChange(selectedItems);
    },
    onKeyDown: function onKeyDown(event) {
      return selectedIndexes.forEach(function (index) {
        if (event.key === _shared.Keys.Down && index === items.length - 1 || event.key === _shared.Keys.Up && index === 0) {
          event.preventDefault();
        }
      });
    },
    size: size,
    value: value
  }), items.map(function (option) {
    return /*#__PURE__*/_react.default.createElement("option", {
      className: "reorder-option",
      key: option.value,
      value: option.value
    }, option.label);
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "clay-reorder-underlay form-control"
  }), showArrows && onItemsChange && /*#__PURE__*/_react.default.createElement("div", {
    className: "clay-reorder-footer"
  }, /*#__PURE__*/_react.default.createElement(_button.default.Group, {
    className: "reorder-order-buttons"
  }, /*#__PURE__*/_react.default.createElement(_button.ClayButtonWithIcon, {
    "aria-label": ariaLabels.reorderUp,
    className: "reorder-button reorder-button-up",
    disabled: firstItemSelected || noItemsSelected || noItems,
    displayType: "secondary",
    onClick: function onClick() {
      return onItemsChange(reorderUp(items, selectedIndexes));
    },
    small: true,
    spritemap: spritemap,
    symbol: "caret-top"
  }), /*#__PURE__*/_react.default.createElement(_button.ClayButtonWithIcon, {
    "aria-label": ariaLabels.reorderDown,
    className: "reorder-button reorder-button-down",
    disabled: lastItemSelected || noItemsSelected || noItems,
    displayType: "secondary",
    onClick: function onClick() {
      return onItemsChange(reorderDown(items, selectedIndexes));
    },
    small: true,
    spritemap: spritemap,
    symbol: "caret-bottom"
  })))));
};
var _default = exports.default = SelectBox;